library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity AlarmFSM is

port(
     clk:       IN STD_LOGIC;
     offon:     IN STD_LOGIC;
     breakin:   IN STD_LOGIC;
	alarm:    OUT STD_LOGIC;
	armed:    OUT STD_LOGIC);

end AlarmFSM;

architecture Behavioral of AlarmFSM is

SIGNAL Q1, Q2: STD_LOGIC;
BEGIN
	PROCESS (clk, Q1, Q2, offon, breakin )
		BEGIN
			IF (rising_edge(clk)) THEN
				Q1 <= (Q1 and (not Q2) and (not offon)) or ((not Q1) and Q2 and (not offon) and breakin);
				Q2 <= ((not Q1) and (not offon) and (not breakin)) or ((not Q1) and (not Q2) and (not offon));
	          END IF;
		END PROCESS;

     armed <= ((not Q1) and (not offon)) or ((not Q2) and (not offon));
	alarm <= (Q1 and (not Q2) and (not offon)) or ((not Q1) and Q2 and (not offon) and breakin);	
	

END Behavioral;
