-- \\FORBES.EE.CALPOLY.EDU\WINTERSTUHOMEDIR\W169S7B10\ALARM
-- VHDL Test Bench created by
-- HDL Bencher 6.1i
-- Tue Mar 01 14:11:36 2005
-- 
-- Notes:
-- 1) This testbench has been automatically generated from
--   your Test Bench Waveform
-- 2) To use this as a user modifiable testbench do the following:
--   - Save it as a file with a .vhd extension (i.e. File->Save As...)
--   - Add it to your project as a testbench source (i.e. Project->Add Source...)
-- 

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY BenchAlarmFSM IS
END BenchAlarmFSM;

ARCHITECTURE testbench_arch OF BenchAlarmFSM IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 87
FILE RESULTS: TEXT OPEN WRITE_MODE IS "results.txt";
	COMPONENT alarmfsm
		PORT (
			clk : In  std_logic;
			offon : In  std_logic;
			breakin : In  std_logic;
			alarm : Out  std_logic;
			armed : Out  std_logic
		);
	END COMPONENT;

	SIGNAL clk : std_logic;
	SIGNAL offon : std_logic;
	SIGNAL breakin : std_logic;
	SIGNAL alarm : std_logic;
	SIGNAL armed : std_logic;

BEGIN
	UUT : alarmfsm
	PORT MAP (
		clk => clk,
		offon => offon,
		breakin => breakin,
		alarm => alarm,
		armed => armed
	);

	PROCESS -- clock process for clk,
	BEGIN
		CLOCK_LOOP : LOOP
		clk <= transport '0';
		WAIT FOR 10 ns;
		clk <= transport '1';
		WAIT FOR 10 ns;
		WAIT FOR 40 ns;
		clk <= transport '0';
		WAIT FOR 40 ns;
		END LOOP CLOCK_LOOP;
	END PROCESS;

	PROCESS   -- Process for clk
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_alarm(
			next_alarm : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (alarm /= next_alarm) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns alarm="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, alarm);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_alarm);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_armed(
			next_armed : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 4096);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (armed /= next_armed) THEN 
				STD.TEXTIO.write(TX_LOC,string'("Error at time="));
				STD.TEXTIO.write(TX_LOC, TX_TIME);
				STD.TEXTIO.write(TX_LOC,string'("ns armed="));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, armed);
				STD.TEXTIO.write(TX_LOC, string'(", Expected = "));
				IEEE.STD_LOGIC_TEXTIO.write(TX_LOC, next_armed);
				STD.TEXTIO.write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				STD.TEXTIO.writeline(results, TX_LOC);
				STD.TEXTIO.Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		offon <= transport '0';
		breakin <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=100 ns
		breakin <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=200 ns
		offon <= transport '1';
		breakin <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=300 ns
		offon <= transport '1';
		breakin <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=400 ns
		offon <= transport '0';
		breakin <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=500 ns
		breakin <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=600 ns
		offon <= transport '1';
		breakin <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=700 ns
		breakin <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=800 ns
		offon <= transport '0';
		breakin <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=900 ns
		breakin <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=1000 ns
		offon <= transport '1';
		breakin <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=1100 ns
		breakin <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=1200 ns
		offon <= transport '0';
		breakin <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=1300 ns
		breakin <= transport '1';
		-- --------------------
		WAIT FOR 100 ns; -- Time=1400 ns
		offon <= transport '1';
		breakin <= transport '0';
		-- --------------------
		WAIT FOR 100 ns; -- Time=1500 ns
		breakin <= transport '1';
		-- --------------------
		WAIT FOR 210 ns; -- Time=1710 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			STD.TEXTIO.write(TX_OUT,string'("No errors or warnings"));
			STD.TEXTIO.writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			STD.TEXTIO.write(TX_OUT, TX_ERROR);
			STD.TEXTIO.write(TX_OUT, string'(
				" errors found in simulation"));
			STD.TEXTIO.writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION alarmfsm_cfg OF BenchAlarmFSM IS
	FOR testbench_arch
	END FOR;
END alarmfsm_cfg;
