library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Encoder is
	 PORT (	
	          inFun: IN STD_LOGIC_VECTOR(7 DOWNTO 0);
			Y0: OUT STD_LOGIC;
			Y1: OUT STD_LOGIC;
			Y2: OUT STD_LOGIC;
			strobe: OUT STD_LOGIC);
end Encoder;

architecture Behavioral of Encoder is

     signal theWise: STD_LOGIC_VECTOR(2 DOWNTO 0);

begin

	theWise <= "111" WHEN (inFun(7) = '1') ELSE
			 "110" WHEN (inFun(6) = '1') ELSE
			 "101" WHEN (inFun(5) = '1') ELSE
			 "100" WHEN (inFun(4) = '1') ELSE
			 "011" WHEN (inFun(3) = '1') ELSE
			 "010" WHEN (inFun(2) = '1') ELSE
			 "001" WHEN (inFun(1) = '1') ELSE
			 "000" WHEN (inFun(0) = '1') ELSE
			 "000";

     Y0 <= theWise(0);
	Y1 <= theWise(1);
	Y2 <= theWise(2);

	strobe  <= '1' WHEN (inFun(7) = '1') ELSE
			 '1' WHEN (inFun(6) = '1') ELSE
			 '1' WHEN (inFun(5) = '1') ELSE
			 '1' WHEN (inFun(4) = '1') ELSE
			 '1' WHEN (inFun(3) = '1') ELSE
			 '1' WHEN (inFun(2) = '1') ELSE
			 '1' WHEN (inFun(1) = '1') ELSE
			 '1' WHEN (inFun(0) = '1') ELSE
			 '0';

end Behavioral;
