--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 6.3.02i
--  \   \         Application : 
--  /   /         Filename : finalalarm.vhf
-- /___/   /\     Timestamp : 03/07/2005 16:26:51
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: finalalarm
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
-- synopsys translate_off
library UNISIM;
use UNISIM.Vcomponents.ALL;
-- synopsys translate_on

entity finalalarm is
   port ( CLKIN        : in    std_logic; 
          comparatorIN : in    std_logic_vector (3 downto 0); 
          SW5          : in    std_logic; 
          SW6          : in    std_logic; 
          SW7          : in    std_logic; 
          SW8          : in    std_logic; 
          alarmOUT     : out   std_logic; 
          armedOUT     : out   std_logic; 
          CATHY        : out   std_logic; 
          DISPOUT      : out   std_logic_vector (6 downto 0));
end finalalarm;

architecture BEHAVIORAL of finalalarm is
   attribute BOX_TYPE   : string ;
   signal XLXN_1       : std_logic;
   signal XLXN_2       : std_logic;
   signal XLXN_4       : std_logic;
   signal XLXN_5       : std_logic;
   signal XLXN_6       : std_logic;
   signal XLXN_22      : std_logic;
   signal XLXN_54      : std_logic_vector (7 downto 0);
   component comparator
      port ( A   : in    std_logic_vector (3 downto 0); 
             EQL : out   std_logic);
   end component;
   
   component decoder
      port ( A     : in    std_logic; 
             B     : in    std_logic; 
             C     : in    std_logic; 
             D     : in    std_logic; 
             cath  : out   std_logic; 
             disp1 : out   std_logic_vector (6 downto 0));
   end component;
   
   component encoder
      port ( inFun  : in    std_logic_vector (7 downto 0); 
             Y0     : out   std_logic; 
             Y1     : out   std_logic; 
             Y2     : out   std_logic; 
             strobe : out   std_logic);
   end component;
   
   component alarmfsm
      port ( clk     : in    std_logic; 
             offon   : in    std_logic; 
             breakin : in    std_logic; 
             alarm   : out   std_logic; 
             armed   : out   std_logic);
   end component;
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : component is "BLACK_BOX";
   
   component inputconverter
      port ( I3 : in    std_logic; 
             I2 : in    std_logic; 
             I1 : in    std_logic; 
             I0 : in    std_logic; 
             O8 : out   std_logic_vector (7 downto 0));
   end component;
   
begin
   XLXI_1 : comparator
      port map (A(3 downto 0)=>comparatorIN(3 downto 0),      
                EQL=>XLXN_2);
   
   XLXI_2 : decoder
      port map (A=>XLXN_22,      
                B=>XLXN_6,      
                C=>XLXN_5,      
                D=>XLXN_4,      
                cath=>CATHY,      
                disp1(6 downto 0)=>DISPOUT(6 downto 0));
   
   XLXI_3 : encoder
      port map (inFun(7 downto 0)=>XLXN_54(7 downto 0),      
                strobe=>XLXN_1,      
                Y0=>XLXN_4,      
                Y1=>XLXN_5,      
                Y2=>XLXN_6);
   
   XLXI_5 : alarmfsm
      port map (breakin=>XLXN_1,      
                clk=>CLKIN,      
                offon=>XLXN_2,      
                alarm=>alarmOUT,      
                armed=>armedOUT);
   
   XLXI_10 : GND
      port map (G=>XLXN_22);
   
   XLXI_17 : inputconverter
      port map (I0=>SW8,      
                I1=>SW7,      
                I2=>SW6,      
                I3=>SW5,      
                O8(7 downto 0)=>XLXN_54(7 downto 0));
   
end BEHAVIORAL;


